require 'test/unit'
require 'case'
require 'case/core'

class CaseTest < Test::Unit::TestCase
  def test_struct
    [ ::Struct, Case::Struct ].each do |s|
      c = s.new :foo, :bar, :baz
      assert c[1, 2, Object] === c[1, 2, 3]
      assert !( c[1, 2, 3] === c[1, 2, Object] )
    end
  end

  def test_array
    [ ::Array, Case::Array ].each do |c|
      assert c[1, 2, Object] === c[1, 2, 3]
      assert !( c[1, 2, 3] === c[1, 2, Object] )
    end
  end

  def test_cmp
    assert (Case::Cmp > 0) === 1
    assert !((Case::Cmp > 0) === 0)
    assert (Case::Cmp < 0) === -1
    assert !((Case::Cmp < 0) === 0)
    assert (Case::Cmp <= 3) === 3
    assert (Case::Cmp <= 3) === 2
    assert !((Case::Cmp <= 3) === 4)
    assert (Case::Cmp >= 3) === 3
    assert (Case::Cmp >= 3) === 4
    assert !((Case::Cmp >= 3) === 2)
  end

  def test_not
    assert Case::Not['a'] === 'b'
    assert !(Case::Not['a'] === 'a')
  end
end

